Attribute VB_Name = "iGuardAPI"
Option Explicit
'=======================================================================
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
' ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO
' THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
' PARTICULAR PURPOSE.
' Copyright (c) 2000  Lucky Technology
'
' Module Name : iguard.bas
' Version     : 1.0
' Programmed by Jacky Hui
'
'=======================================================================
' Sample BAS Module connect directly to iguard.dll, help the
' VB application implement iGuard API.
'
' Important: When using VB with DLL, always save your code
'            before doing any debug or program execution.
'            Program with DLL call can easily cause exception
'            error, and you may lost all your work.
'=======================================================================

'
' Global / Private variables and constants
'
' - Init DLL Parameter
Private Const INIT_SHOWERRMSG = False       ' Show error message dialog if True
Private Const INIT_SHOWLOGIN = True         ' Show login dialog box if True
Private Const WM_IGUARDEVENT = 0            ' 0 to disable the message
'
Private Const BUFFERSIZE = 4096             ' Size of Buffer
Private Buffer As String * BUFFERSIZE       ' Buffer for pass/receive string to/from iGuard API
Private Buffer2 As String * BUFFERSIZE      ' Buffer for pass/receive string to/from iGuard API


'
' API Function Declaration
' For the details information of each function, please
' refer to the iGuard API Reference
'
' 1. iGuard Management Functions
Declare Function iGuard_Initialize Lib "iguard.dll" (ByVal hWnd As Long, ByVal bShowMsg As Long, ByVal bShowLogin As Long, ByVal dwWndMsg As Long) As Long
Declare Function iGuard_Exit Lib "iguard.dll" () As Long
Declare Function iGuard_GetVersion Lib "iguard.dll" (ByVal lpzUrl As String, ByVal lpzBuffer As String, ByVal dwBufferSize As Long) As Long
Declare Function iGuard_GetSerialNo Lib "iguard.dll" (ByVal lpzUrl As String, ByVal lpzBuffer As String, ByVal nMaxLen As Long) As Long
Declare Function iGuard_GetTerminalName Lib "iguard.dll" (ByVal lpzUrl As String, ByVal lpzBuffer As String, ByVal nMaxLen As Long) As Long
Declare Function iGuard_IsMaster Lib "iguard.dll" (ByVal lpzUrl As String) As Long
Declare Function iGuard_GetLastError Lib "iguard.dll" () As Long
Declare Function iGuard_Login Lib "iguard.dll" (ByVal lpzUrl As String, ByVal lpzUserName As String, ByVal lpzPassword As String) As Long
Declare Function iGuard_LoginDialogBox Lib "iguard.dll" (ByVal lpzUrl As String) As Boolean
Declare Function iGuard_GetLogin Lib "iguard.dll" (ByVal lpzUrl As String, ByVal lpzUserName As String, ByVal lpzPassword As String) As Boolean
' 2. iGuard Database Functions
Declare Function iGuard_BackupDatabase Lib "iguard.dll" (ByVal lpzUrl As String, ByVal lpzFileName As String) As Long
Declare Function iGuard_RestoreDatabase Lib "iguard.dll" (ByVal lpzUrl As String, ByVal lpzFileName As String) As Long
Declare Function iGuard_Export Lib "iguard.dll" (ByVal lpzUrl As String, ByVal lpzFileName As String, ByRef pDefinition As EXPORT_DEFINITION_T) As Long
'    Department Database
Declare Function iGuard_DatabaseDepartmentList Lib "iguard.dll" (ByVal lpzUrl As String, ByVal lpzDepartmentList As String, ByVal nMaxLen As Long, nListLen As Long) As Long
Declare Function iGuard_DBFindDepartment Lib "iguard.dll" Alias "iGuard_DatabaseFind" (ByVal lpzUrl As String, ByVal lpzDatabaseName As String, ByVal lpzID As String, ByRef pRecord As DB_DEPARTMENT_T, ByVal nMaxLen As Long) As Long
Declare Function iGuard_DBFirstDepartment Lib "iguard.dll" Alias "iGuard_DatabaseFirst" (ByVal lpzUrl As String, ByVal lpzDatabaseName As String, ByRef pRecord As DB_DEPARTMENT_T, ByVal nMaxLen As Long) As Long
Declare Function iGuard_DBPreviousDepartment Lib "iguard.dll" Alias "iGuard_DatabasePrevious" (ByVal lpzUrl As String, ByVal lpzDatabaseName As String, ByRef pRecord As DB_DEPARTMENT_T, ByVal nMaxLen As Long) As Long
Declare Function iGuard_DBNextDepartment Lib "iguard.dll" Alias "iGuard_DatabaseNext" (ByVal lpzUrl As String, ByVal lpzDatabaseName As String, ByRef pRecord As DB_DEPARTMENT_T, ByVal nMaxLen As Long) As Long
Declare Function iGuard_DBLastDepartment Lib "iguard.dll" Alias "iGuard_DatabaseLast" (ByVal lpzUrl As String, ByVal lpzDatabaseName As String, ByRef pRecord As DB_DEPARTMENT_T, ByVal nMaxLen As Long) As Long
Declare Function iGuard_DBDeleteDepartment Lib "iguard.dll" Alias "iGuard_DatabaseDelete" (ByVal lpzUrl As String, ByVal lpzDatabaseName As String, ByVal lpzID As String) As Long
Declare Function iGuard_DBUpdateDepartment Lib "iguard.dll" Alias "iGuard_DatabaseUpdate" (ByVal lpzUrl As String, ByVal lpzDatabaseName As String, ByRef pRecord As DB_DEPARTMENT_T, ByVal nMaxLen As Long, ByVal nOption As Long) As Long
Declare Function iGuard_DBInsertDepartment Lib "iguard.dll" Alias "iGuard_DatabaseInsert" (ByVal lpzUrl As String, ByVal lpzDatabaseName As String, ByRef pRecord As DB_DEPARTMENT_T, ByVal nMaxLen As Long) As Long
'    Employee Database
Declare Function iGuard_DatabaseEmployeeList Lib "iguard.dll" (ByVal lpzUrl As String, ByVal lpzEmployeeList As String, ByVal nMaxLen As Long, nListLen As Long) As Long
Declare Function iGuard_DBFindEmployee Lib "iguard.dll" Alias "iGuard_DatabaseFind" (ByVal lpzUrl As String, ByVal lpzDatabaseName As String, ByVal lpzID As String, ByRef pRecord As DB_EMPLOYEE_T, ByVal nMaxLen As Long) As Long
Declare Function iGuard_DBFirstEmployee Lib "iguard.dll" Alias "iGuard_DatabaseFirst" (ByVal lpzUrl As String, ByVal lpzDatabaseName As String, ByRef pRecord As DB_EMPLOYEE_T, ByVal nMaxLen As Long) As Long
Declare Function iGuard_DBPreviousEmployee Lib "iguard.dll" Alias "iGuard_DatabasePrevious" (ByVal lpzUrl As String, ByVal lpzDatabaseName As String, ByRef pRecord As DB_EMPLOYEE_T, ByVal nMaxLen As Long) As Long
Declare Function iGuard_DBNextEmployee Lib "iguard.dll" Alias "iGuard_DatabaseNext" (ByVal lpzUrl As String, ByVal lpzDatabaseName As String, ByRef pRecord As DB_EMPLOYEE_T, ByVal nMaxLen As Long) As Long
Declare Function iGuard_DBLastEmployee Lib "iguard.dll" Alias "iGuard_DatabaseLast" (ByVal lpzUrl As String, ByVal lpzDatabaseName As String, ByRef pRecord As DB_EMPLOYEE_T, ByVal nMaxLen As Long) As Long
Declare Function iGuard_DBDeleteEmployee Lib "iguard.dll" Alias "iGuard_DatabaseDelete" (ByVal lpzUrl As String, ByVal lpzDatabaseName As String, ByVal lpzID As String) As Long
Declare Function iGuard_DBUpdateEmployee Lib "iguard.dll" Alias "iGuard_DatabaseUpdate" (ByVal lpzUrl As String, ByVal lpzDatabaseName As String, ByRef pRecord As DB_EMPLOYEE_T, ByVal nMaxLen As Long, ByVal nOption As Long) As Long
Declare Function iGuard_DBInsertEmployee Lib "iguard.dll" Alias "iGuard_DatabaseInsert" (ByVal lpzUrl As String, ByVal lpzDatabaseName As String, ByRef pRecord As DB_EMPLOYEE_T, ByVal nMaxLen As Long) As Long

'
' Structure Declaration
'
Public Type DB_EMPLOYEE_T       ' Employee Record

    sID As String * 17          ' Employee ID
    sLastName As String * 21    ' Last Name
    sFirstName As String * 21   ' First Name
    sOtherName As String * 21   ' Other Name / Title
    nStatus As Long             ' Employee Status
                                '  // Bit   Descriptions
                                '  //--------------------------------------------------------------
                                '  //  0    Employee Active, 1 if employee actived
                                '  //  1    Fingerpritns enrolled, 1 if employee already enrolled.
                                '  // 2-14  Reserved.
                                '  //  15   Use Password, 1 if employee have password.
    RcdID As Long               ' Record ID (necessary when updating and deleting a record
    sPassword As String * 17    ' Employee Access Password (Write Only)

End Type

Public Type DB_DEPARTMENT_T         ' Department Record
    
    sID As String * 17
    sDepartmentName As String * 31
    nStatus As Long
    Res0M As Long                   ' Restriction for Sunday's Morning
    Res0A As Long                   ' Restriction for Sunday's Afternoon
    Res1M As Long
    Res1A As Long
    Res2M As Long
    Res2A As Long
    Res3M As Long
    Res3A As Long
    Res4M As Long
    Res4A As Long
    Res5M As Long
    Res5A As Long
    Res6M As Long
    Res6A As Long
    Res7M As Long
    Res7A As Long                   ' Restriction for Holiday's Morning
    RcdID As Long                   ' Restriction for Holiday's Morning
    
End Type

Public Type EXPORT_DEFINITION_T     ' Structure for define which access logs to export

    nSize As Long
    nReport As Long
    nFormat As Long
    bIncludeHeader As Long
    szID As String * 17
    szDepartment As String * 17
    nPeriod As Long
    szDateFrom As String * 16
    szDateTo As String * 16

End Type
'
' iGuardGetVersion()
' Getting firmware version from iGuard
'
Public Function iGuardGetVersion(URL As String) As String
    
    Dim ReturnString As String
    
    If URL <> "" Then
        If iGuard_GetVersion(URL, Buffer, BUFFERSIZE) Then
            ReturnString = Buffer
        Else
            ReturnString = ""
        End If
    End If
    
    iGuardGetVersion = ReturnString
    
End Function
'
' iGuardGetSerialNo()
' Getting serial no. from iGuard
'
Public Function iGuardGetSerialNo(URL As String) As String
    
    Dim ReturnString As String
    
    If URL <> "" Then
        If iGuard_GetSerialNo(URL, Buffer, BUFFERSIZE) Then
            ReturnString = Buffer
        Else
            ReturnString = ""
        End If
    End If
    
    iGuardGetSerialNo = ReturnString
    
End Function
'
' iGuardInitialize()
' iGuard API Initialize
'
Public Function iGuardInitialize(Handle As Long) As Boolean
    
    '
    ' Current setting:
    '   - Don't show error message dialog box
    '   - Show Login dialog box when necessary
    '   - Don't use user windows message
    '
    iGuardInitialize = iGuard_Initialize(Handle, INIT_SHOWERRMSG, INIT_SHOWLOGIN, WM_IGUARDEVENT)

End Function
'
' iGuardExit()
' iGuard API Shutdown
'
Public Sub iGuardExit()
    
    iGuard_Exit
    
End Sub
'
' iGuardTerminalName()
' Getting iGuard Terminal's Name
'
Public Function iGuardTerminalName(URL As String) As String

    Dim ReturnString As String
    
    If URL <> "" Then
        If iGuard_GetTerminalName(URL, Buffer, 100) Then
            ReturnString = Buffer
        Else
            ReturnString = ""
        End If
    End If
    
    iGuardTerminalName = ReturnString
    
End Function
'
' iGuardEmployeeList()
' Getting the list of employees from iGuard
'
Public Function iGuardEmployeeList(URL As String) As String
    
    Dim ReturnString As String
    Dim nCount As Long
    
    If URL <> "" Then
        If iGuard_DatabaseEmployeeList(URL, Buffer, BUFFERSIZE, nCount) Then
            ReturnString = Buffer
        Else
            ReturnString = ""
        End If
        If nCount > BUFFERSIZE Then
            ReturnString = ""   ' Check whether the buffer can hold list
        Else
            ReturnString = Mid(ReturnString, 1, nCount)
        End If
    End If
        
    iGuardEmployeeList = ReturnString
    
End Function
'
' iGuardDepartmentList()
' Retrieve the list of departments from iGuard
'
Public Function iGuardDepartmentList(URL As String) As String
    
    Dim ReturnString As String
    Dim nCount As Long
    
    If URL <> "" Then
        If iGuard_DatabaseDepartmentList(URL, Buffer, BUFFERSIZE, nCount) Then
            ReturnString = Buffer
        Else
            ReturnString = ""
        End If
        
        If nCount > BUFFERSIZE Then
            ReturnString = ""   ' Check whether the buffer can hold list
        Else
            ReturnString = Mid(ReturnString, 1, nCount)
        End If
    End If
        
    iGuardDepartmentList = ReturnString

End Function
'
' BuildList()
' Export the list (i.e. employee, department and terminals)
' retrieved from iGuard to a ComboBox
'
Public Sub BuildList(DbList As String, VbCombo As ComboBox)
    
    Dim s As String
    Dim t As String
    Dim i As Integer, j As Integer, k As Integer
    Dim l As Integer
        
    l = Len(DbList)
    s = Mid(DbList, 1, l)
    VbCombo.Clear
    
    Do While s <> ""
        
        i = InStr(1, s, "|")
        
        If i > 0 Then
            t = Mid(s, 1, i - 1)
            s = Mid(s, i + 1)
            VbCombo.AddItem (t)
        Else
            If s <> "" Then
                VbCombo.AddItem (s)
                s = ""
            End If
        End If
    Loop

End Sub
'
' iGuardFindEmployee()
' Find and retrieve a employee record
'
Public Function iGuardFindEmployee(URL As String, eid As String, eRcd As DB_EMPLOYEE_T) As Boolean
    
    Dim bResult As Boolean
    Dim nMaxLen As Long
        
    nMaxLen = Len(eRcd)
    
    bResult = False
        
    If eid <> "" And URL <> "" Then
    
        If iGuard_DBFindEmployee(URL, "EMPY", eid, eRcd, nMaxLen) Then
            
            bResult = True
                               
        End If
    
    End If
    
    
    iGuardFindEmployee = bResult

End Function
'
' iGuardIsMaster()
' Check whether the iGuard configured as Master/Slave
'
Public Function iGuardIsMaster(URL As String) As Boolean

    Dim bResult As Boolean
    
    bResult = False
    
    If URL <> "" Then
        If iGuard_IsMaster(URL) Then
            bResult = True
        End If
    End If
    
    iGuardIsMaster = bResult
    
End Function
'
' iGuardFindDepartment()
' Find and retrieve a department record
'
Public Function iGuardFindDepartment(URL As String, deptid As String, dRcd As DB_DEPARTMENT_T) As Boolean

    Dim bResult As Boolean
    Dim nMaxLen As Long
        
    nMaxLen = Len(dRcd)
    
    bResult = False
        
    If deptid <> "" And URL <> "" Then
    
        If iGuard_DBFindDepartment(URL, "DEPT", deptid, dRcd, nMaxLen) Then
            
            bResult = True
                               
        End If
    
    End If
    
    iGuardFindDepartment = bResult

End Function
'
' iGuardRestoreDb
' Restore the iGuard's database from a file in local PC
'
Public Function iGuardRestoreDb(URL As String, Optional filename As String) As Boolean
    
    If URL <> "" Then
        iGuardRestoreDb = iGuard_RestoreDatabase(URL, filename)
    End If
    
End Function
'
' iGuardBackupDb()
' Backup the iGuard's database to a file in local PC
'
Public Function iGuardBackupDb(URL As String, Optional filename As String) As Boolean
    
    If URL <> "" Then
        iGuardBackupDb = iGuard_BackupDatabase(URL, filename)
    End If

End Function
'
' iGuardLogin()
' Send login information to iGuard Terminal
'
Public Function iGuardLogin(URL As String, loginname As String, loginpassword As String) As Boolean

    If URL <> "" Then
        iGuardLogin = iGuard_Login(URL, loginname, loginpassword)
    End If
    
End Function
'
' iGuardGetLastError()
' Retrieve the Last Error No. of API
'
Public Function iGuardGetLastError() As Long
    
    iGuardGetLastError = iGuard_GetLastError()

End Function
'
' iGuardLoginDialog()
' Show the login dialog box and let user key in
'
Public Function iGuardLoginDialog(URL As String) As Boolean

    If URL <> "" Then
        iGuardLoginDialog = iGuard_LoginDialogBox(URL)
    End If
    
End Function
'
' iGuardGetLogin()
' Retrieve the login information from API
'
Public Function iGuardGetLogin(URL As String, loginname As String, loginpassword As String) As Boolean

    Dim bResult As Boolean
    Dim l As Integer
    
    bResult = False
               
    If URL <> "" Then
        bResult = iGuard_GetLogin(URL, Buffer, Buffer2)
        
        If bResult Then
            loginname = CTrim(Buffer)
            loginpassword = CTrim(Buffer2)
            
            If loginname = "" Or loginpassword = "" Then
                bResult = False
            End If
        Else
            loginname = ""
            loginpassword = ""
        End If
    End If
    
    iGuardGetLogin = bResult
        
End Function
'
' CTrim()
' Remove invalid character from string (i.e. API is written in C,
' and all it's string is null terminated, this function remove
' all the characters after null)
'
Public Function CTrim(str As String) As String

    Dim i As Integer
    Dim l As Integer
    Dim s As String
        
    l = Len(str)
    
    For i = 1 To l
    
        If Asc(Mid(str, i, 1)) < 32 Then
            Exit For
        End If
    
    Next i
    
    If i > 1 Then
        s = Trim(Mid(str, 1, i - 1))
    End If

    CTrim = s

End Function
'
' iGuardEmployeeDbFirst()
' Retrieve the first employee record in iGuard's employee database
'
Public Function iGuardEmployeeDbFirst(URL As String, eRcd As DB_EMPLOYEE_T) As Boolean
    
    Dim bResult As Boolean
    Dim nMaxLen As Long
        
    nMaxLen = Len(eRcd)
    
    bResult = False
        
    If URL <> "" Then
    
        If iGuard_DBFirstEmployee(URL, "EMPY", eRcd, nMaxLen) Then
            
            bResult = True
                               
        End If
    
    End If
    
    iGuardEmployeeDbFirst = bResult

End Function
'
' iGuardEmployeeDbPrevious()
' Retrieve the previous employee record in iGuard's employee database
'
Public Function iGuardEmployeeDbPrevious(URL As String, eRcd As DB_EMPLOYEE_T) As Boolean
    
    Dim bResult As Boolean
    Dim nMaxLen As Long
        
    nMaxLen = Len(eRcd)
    
    bResult = False
        
    If URL <> "" Then
    
        If iGuard_DBPreviousEmployee(URL, "EMPY", eRcd, nMaxLen) Then
            
            bResult = True
                               
        End If
    
    End If
    
    iGuardEmployeeDbPrevious = bResult

End Function
'
' iGuardEmployeeDbNext()
' Retrieve the Next employee record in iGuard's employee database
'
Public Function iGuardEmployeeDbNext(URL As String, eRcd As DB_EMPLOYEE_T) As Boolean
    
    Dim bResult As Boolean
    Dim nMaxLen As Long
        
    nMaxLen = Len(eRcd)
    
    bResult = False
        
    If URL <> "" Then
    
        If iGuard_DBNextEmployee(URL, "EMPY", eRcd, nMaxLen) Then
            
            bResult = True
                               
        End If
    
    End If
    
    iGuardEmployeeDbNext = bResult

End Function
'
' iGuardEmployeeDbLast()
' Retrieve the last employee record in iGuard's employee database
'
Public Function iGuardEmployeeDbLast(URL As String, eRcd As DB_EMPLOYEE_T) As Boolean
    
    Dim bResult As Boolean
    Dim nMaxLen As Long
        
    nMaxLen = Len(eRcd)
    
    bResult = False
        
    If URL <> "" Then
    
        If iGuard_DBLastEmployee(URL, "EMPY", eRcd, nMaxLen) Then
            
            bResult = True
                               
        End If
    
    End If
    
    iGuardEmployeeDbLast = bResult

End Function
'
' iGuardEmployeeDbDelete()
' Delete a employee record from iGuard's employee database
'
Public Function iGuardEmployeeDbDelete(URL As String, eid As String) As Boolean

    Dim bResult As Boolean
    
    bResult = False
    
    If URL <> "" Then
    
        If iGuard_DBDeleteEmployee(URL, "EMPY", eid) Then
            bResult = True
        End If
    End If
    
    iGuardEmployeeDbDelete = True
    
End Function
'
' iGuardEmployeeDbUpdate()
' Update a employee record from iGuard's employee database
'
Public Function iGuardEmployeedbUpdate(URL As String, eRcd As DB_EMPLOYEE_T, nOption As Long) As Boolean

    Dim bResult As Boolean
    Dim nMaxLen As Long
        
    nMaxLen = Len(eRcd)
    
    bResult = False
        
    If URL <> "" Then
    
        If iGuard_DBUpdateEmployee(URL, "EMPY", eRcd, nMaxLen, nOption) Then
            
            bResult = True
                               
        End If
    
    End If
    
    iGuardEmployeedbUpdate = bResult
    
End Function
'
' iGuardEmployeeDbInsert()
' Delete a employee record from iGuard's employee database
'
Public Function iGuardEmployeeDbInsert(URL As String, eRcd As DB_EMPLOYEE_T) As Boolean

    Dim bResult As Boolean
    Dim nMaxLen As Long
        
    nMaxLen = Len(eRcd)
    
    bResult = False
        
    If URL <> "" Then
    
        If iGuard_DBInsertEmployee(URL, "EMPY", eRcd, nMaxLen) Then
            
            bResult = True
                               
        End If
    
    End If
    
    iGuardEmployeeDbInsert = bResult
    
End Function
'
' iGuardIsLogined()
' Check whether iGuard is logined or not
'
Public Function iGuardIsLoginned(URL As String)
    
    Dim blogin As Boolean
    Dim lname As String
    Dim lpassword As String
    
    blogin = False
        
    If URL <> "" Then
        blogin = iGuardGetLogin(URL, lname, lpassword)     ' Getting current login information
    End If
    
    iGuardIsLoginned = blogin
    
End Function
'
' iGuardDepartmentDbFirst()
' Retrieve the first Department record in iGuard's Department database
'
Public Function iGuardDepartmentDbFirst(URL As String, dRcd As DB_DEPARTMENT_T) As Boolean
    
    Dim bResult As Boolean
    Dim nMaxLen As Long
        
    nMaxLen = Len(dRcd)
    
    bResult = False
        
    If URL <> "" Then
    
        If iGuard_DBFirstDepartment(URL, "DEPT", dRcd, nMaxLen) Then
            
            bResult = True
                               
        End If
    
    End If
    
    iGuardDepartmentDbFirst = bResult

End Function
'
' iGuardDepartmentDbPrevious()
' Retrieve the previous Department record in iGuard's Department database
'
Public Function iGuardDepartmentDbPrevious(URL As String, dRcd As DB_DEPARTMENT_T) As Boolean
    
    Dim bResult As Boolean
    Dim nMaxLen As Long
        
    nMaxLen = Len(dRcd)
    
    bResult = False
        
    If URL <> "" Then
    
        If iGuard_DBPreviousDepartment(URL, "DEPT", dRcd, nMaxLen) Then
            
            bResult = True
                               
        End If
    
    End If
    
    iGuardDepartmentDbPrevious = bResult

End Function
'
' iGuardDepartmentDbNext()
' Retrieve the Next Department record in iGuard's Department database
'
Public Function iGuardDepartmentDbNext(URL As String, dRcd As DB_DEPARTMENT_T) As Boolean
    
    Dim bResult As Boolean
    Dim nMaxLen As Long
        
    nMaxLen = Len(dRcd)
    
    bResult = False
        
    If URL <> "" Then
    
        If iGuard_DBNextDepartment(URL, "DEPT", dRcd, nMaxLen) Then
            
            bResult = True
                               
        End If
    
    End If
    
    iGuardDepartmentDbNext = bResult

End Function
'
' iGuardDepartmentDbLast()
' Retrieve the last Department record in iGuard's Department database
'
Public Function iGuardDepartmentDbLast(URL As String, dRcd As DB_DEPARTMENT_T) As Boolean
    
    Dim bResult As Boolean
    Dim nMaxLen As Long
        
    nMaxLen = Len(dRcd)
    
    bResult = False
        
    If URL <> "" Then
    
        If iGuard_DBLastDepartment(URL, "EMPY", dRcd, nMaxLen) Then
            
            bResult = True
                               
        End If
    
    End If
    
    iGuardDepartmentDbLast = bResult

End Function
'
' iGuardDepartmentDbDelete()
' Delete a Department record from iGuard's Department database
'
Public Function iGuardDepartmentDbDelete(URL As String, did As String) As Boolean

    Dim bResult As Boolean
    
    bResult = False
    
    If URL <> "" Then
    
        If iGuard_DBDeleteDepartment(URL, "DEPT", did) Then
            bResult = True
        End If
    End If
    
    iGuardDepartmentDbDelete = True
    
End Function
'
' iGuardDepartmentDbUpdate()
' Update a Department record from iGuard's Department database
'
Public Function iGuardDepartmentdbUpdate(URL As String, dRcd As DB_DEPARTMENT_T, nOption As Long) As Boolean

    Dim bResult As Boolean
    Dim nMaxLen As Long
        
    nMaxLen = Len(dRcd)
    
    bResult = False
        
    If URL <> "" Then
    
        If iGuard_DBUpdateDepartment(URL, "DEPT", dRcd, nMaxLen, nOption) Then
            
            bResult = True
                               
        End If
    
    End If
    
    iGuardDepartmentdbUpdate = bResult
    
End Function
'
' iGuardDepartmentDbInsert()
' Delete a Department record from iGuard's Department database
'
Public Function iGuardDepartmentDbInsert(URL As String, dRcd As DB_DEPARTMENT_T) As Boolean

    Dim bResult As Boolean
    Dim nMaxLen As Long
        
    nMaxLen = Len(dRcd)
    
    bResult = False
        
    If URL <> "" Then
    
        If iGuard_DBInsertDepartment(URL, "DEPT", dRcd, nMaxLen) Then
            
            bResult = True
                               
        End If
    
    End If
    
    iGuardDepartmentDbInsert = bResult
    
End Function
'
' iGuardExport()
' Export the access log / attendance report to a
' file in local PC
'
Public Function iGuardExport(URL As String, ByRef pDefinition As EXPORT_DEFINITION_T) As Boolean
    
    Dim bResult As Boolean
    
    bResult = False
        
    If URL <> "" Then
    
        bResult = iGuard_Export(URL, "", pDefinition)
            
    End If

    iGuardExport = bResult

End Function
'
' SetExportDefinition()
' Set the export definition structure by dialog
'
Public Function SetExportDefinition(ByRef definition As EXPORT_DEFINITION_T, EmployeeCombo As ComboBox, DepartmentCombo As ComboBox) As Boolean
    
    Dim i As Integer
    Dim bResult As Boolean
        
    bResult = False
    ExportOption.ReportType(0).Value = True
    ExportOption.ReportFormat(0).Value = True
    ExportOption.IncludeHeader.Value = 1
    ExportOption.ByEmployee.Value = 0
    ExportOption.ByDepartment.Value = 0
    ExportOption.DateRange.ListIndex = 0
    ExportOption.DateFrom.Text = "MM/DD/YYYY"
    ExportOption.DateTo.Text = "MM/DD/YYYY"
    ExportOption.DepartmentID.Enabled = False
    ExportOption.EmployeeID.Enabled = False
        
    ExportOption.EmployeeID.Clear
    For i = 0 To EmployeeCombo.ListCount
        ExportOption.EmployeeID.AddItem (EmployeeCombo.List(i))
    Next i
    
    ExportOption.DepartmentID.Clear
    For i = 0 To DepartmentCombo.ListCount
        ExportOption.DepartmentID.AddItem (DepartmentCombo.List(i))
    Next i
           
    ExportOption.Show (1)
    
    If bResult Then
        definition.bIncludeHeader = ExportOption.IncludeHeader.Value
        
        If ExportOption.ReportFormat(0).Value = 1 Then
            definition.nFormat = 0
        Else
            definition.nFormat = 1
        End If
        
        If ExportOption.ReportType(0).Value = 1 Then
            definition.nReport = 0
        Else
            definition.nReport = 1
        End If
        
        If ExportOption.ByEmployee.Value = 1 And ExportOption.EmployeeID.ListIndex >= 0 Then
            definition.szID = ExportOption.EmployeeID.Text
        Else
            definition.szID = ""
        End If
        
        If ExportOption.ByDepartment.Value = 1 And ExportOption.DepartmentID.ListIndex >= 0 Then
            definition.szDepartment = ExportOption.DepartmentID.Text
        Else
            definition.szDepartment = ""
        End If
    
        If ExportOption.DateRange.ListIndex >= 0 Then
            definition.nPeriod = ExportOption.DateRange.ListIndex
        Else
            definition.nPeriod = 0
        End If
            
        If definition.nPeriod = 1 Then
            definition.szDateFrom = ExportOption.DateFrom.Text
            definition.szDateTo = ExportOption.DateTo.Text
        Else
            definition.szDateFrom = ""
            definition.szDateTo = ""
        
        End If
    
    End If
        
    SetExportDefinition = bResult
        
End Function

