//
// Database.h
//////////////////////////////////////////////////////////////////////
// Database Record Declaration
//////////////////////////////////////////////////////////////////////

#ifndef __DATABASE_H__
#define __DATABASE_H__

//Database Name
#define DBNAME_EMPLOYEE		"EMPY"
#define DBNAME_ACCESSLOG	"TMLG"
#define DBNAME_DEPARTMENT	"DEPT"
#define DBNAME_TERMINALS	"SLAV"

// Record ID for iGuard Database Record Handle
typedef DWORD RCDID;
typedef RCDID *PRCDID;

#define TYPE_TIMERESTRICTION

typedef struct TIMERESTRICTION {
	DWORD Morning;		//00:00 to 11:59
	DWORD Afternoon;	//12:00 to 23:59
} TimeRestriction, *LPTimeRestriction;

typedef struct DB_EMPLOYEE_T {		//Employee Record
	char id[17];
	char lastname[21];
	char firstname[21];
	char othername[21];
	int status;
	RCDID rcdid;
	char password[17];
} DB_EMPLOYEE, *LPDB_EMPLOYEE;

typedef struct DB_EMPLOYEE_T_X {	//Employee Search 
	int Status;
	char deptid[17];
	char lastname[21];
	char firstname[21];
} DB_EMPLOYEE_X, *LPDB_EMPLOYEE_X;

typedef struct DB_TIMELOG_T {		//Access Log
	char id[17];
	FILETIME logTime;
	char terminalID[17];
	int status;						//Bit 0 : In(0) / Out(1)
									//Bit 7 : Punch(0) / Manual Added(1)
	RCDID rcdid;
} DB_TIMELOG, *LPDB_TIMELOG;

typedef struct DB_TIMELOG_T_X {	//Access Log Search
	char id[17];
	FILETIME From;
	FILETIME To;
	char TerminalID[17];
	char DeptID[17];
} DB_TIMELOG_X, *LPDB_TIMELOG_X;

typedef struct DB_DEPARTMENT_T {
	char id[17];
	char departmentname[31];
	int status;
	TimeRestriction restriction[8];
	RCDID rcdid;
} DB_DEPARTMENT, *LPDB_DEPARTMENT;

typedef struct DB_TERMINALS_T {
	char id[17];
	DWORD ip;
	int flat;
	DWORD reserved;
	char description[41];
	RCDID rcdid;
} DB_TERMINALS, *LPDB_TERMINALS;

typedef struct DB_ATTENDANCE_T {
	char szID[17];
	FILETIME inout[6];
	char isMore;
	RCDID rcdid_1;
	RCDID rcdid_2;
} DB_ATTENDANCE, *LPDB_ATTENDANCE;

#endif //__DATABASE_H__